//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <dir.h> // fonction fnsplit
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CPort"
#pragma link "CPortCtl"
#pragma resource "*.dfm"

// (C) Fabrice Sincre ; avril 2007
// Borland Builder 5
// Composant ComPort

int j=0;
double y;
double tmin = 8.0 , tmin0 = 8.0;
double tmax = 40.0 ,tmax0 = 40.0;
double sdiv = 60.0 , sdiv0 = 60.0 ;
double samplingperiod = 0.125 , samplingperiod0 = 0.125 ;
double deltat ,deltas ;
double temperature[30] ={0.0} ; // contient les 30 dernires mesures
double temperature_moy = 0.0 ; // moyenne glissante des 30 dernires mesures
unsigned char tableau[1]= {'t'};
AnsiString temp_lue ="00,0";
bool seconde = true,  seconde0 = true;
bool minute = false,  minute0 = false;
bool heure = false,  heure0 = false;
bool jour = false,  jour0 = false;

char tabulation ='\t';  // tabulation horizontale, code ASCII 0x09
char retour ='\r';      // retour chariot, code ASCII 0x0D
char saut ='\n';        // saut  la ligne, code ASCII 0x0A
int iFileHandle;
bool sauvegardeencours = false ;
AnsiString time0, timebak ="";

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
//clear screen

Image1->Canvas->Brush ->Color = clWhite;
Image1->Canvas->FillRect(Rect(0,0,480,320));

// grilles
Image1->Canvas->Pen->Color = clBlue; // couleur du trait
Image1->Canvas->Pen->Width = 1; // largeur du trait
Image1->Canvas->Pen->Style = psDot	; // Style du trait (pointill)

for (int i = 0 ; i<9 ; i++)       // 8 lignes
{
    Image1->Canvas->MoveTo(0 , 40*i);
    Image1->Canvas->LineTo(480 , 40*i);
}
for (int i = 0 ; i<13 ; i++)   // 12 colonnes
{
    Image1->Canvas->MoveTo(40*i , 0);
    Image1->Canvas->LineTo(40*i , 320);
}
Image1->Canvas->MoveTo(-100 , 160);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
Timer3->Enabled=false;
try
{
seconde = RadioButton4->Checked ;
minute = RadioButton1->Checked ;
heure =  RadioButton2->Checked ;
jour =  RadioButton3->Checked ;

tmax =(Edit1->Text).ToDouble(); //conversion de AnsiString en Double
tmin =(Edit2->Text).ToDouble(); //conversion de AnsiString en Double
sdiv =(Edit3->Text).ToDouble(); //conversion de AnsiString en Double
}
catch(...)
{
Application->MessageBox("Valeur non valide !","Erreur 4",MB_OK);
tmax = tmax0;
tmin = tmin0;
sdiv = sdiv0;
seconde = seconde0;
minute = minute0;
heure = heure0;
jour = jour0;
Edit1->Text = FloatToStrF(tmax,ffFixed,15,2);
Edit2->Text = FloatToStrF(tmin,ffFixed,15,2);
Edit3->Text = FloatToStrF(sdiv,ffFixed,15,2);
RadioButton4->Checked = seconde ;
RadioButton1->Checked = minute ;
RadioButton2->Checked = heure;
RadioButton3->Checked = jour;
}

samplingperiod  = sdiv / 480.0 ;    // en s
if (RadioButton1->Checked == true) samplingperiod = samplingperiod*60.0 ;
if (RadioButton2->Checked == true) samplingperiod = samplingperiod*3600.0 ;
if (RadioButton3->Checked == true) samplingperiod = samplingperiod*86400.0 ;

if ((tmax <= tmin) || (samplingperiod < 0.125))
{
        if (tmax <= tmin) Application->MessageBox ("T max doit tre suprieure  T min !","Erreur 1",MB_OK);
        if (samplingperiod < 0.125) Application->MessageBox("La priode doit tre suprieure  60 s !","Erreur2",MB_OK);
        tmax = tmax0;
        tmin = tmin0;
        sdiv = sdiv0;
        samplingperiod =  samplingperiod0;
        seconde = seconde0;
        minute = minute0;
        heure = heure0;
        jour = jour0;
}

tmax0 = tmax;
tmin0 = tmin;
sdiv0 = sdiv;
samplingperiod0 =  samplingperiod;
seconde0 = seconde;
minute0 = minute;
heure0 = heure;
jour0 = jour;

deltat = (tmax - tmin)/8.0 ;
deltas =  sdiv /12.0 ;

Timer3 -> Interval = samplingperiod*1000.0;
Labelsamplingperiod -> Caption = FloatToStrF(samplingperiod,ffFixed,15,3) + " s";
Edit1->Text = FloatToStrF(tmax,ffFixed,15,2);
Edit2->Text = FloatToStrF(tmin,ffFixed,15,2);
Edit3->Text = FloatToStrF(sdiv,ffFixed,15,2);
RadioButton4->Checked = seconde ;
RadioButton1->Checked = minute ;
RadioButton2->Checked = heure;
RadioButton3->Checked = jour;

Labelx0 -> Caption = FloatToStrF(tmin,ffFixed,15,2) + "C";
Labelx1 -> Caption = FloatToStrF(tmin + 1.0*deltat,ffFixed,15,2)+ "C";
Labelx2 -> Caption = FloatToStrF(tmin + 2.0*deltat,ffFixed,15,2)+ "C";
Labelx3 -> Caption = FloatToStrF(tmin + 3.0*deltat,ffFixed,15,2)+ "C";
Labelx4 -> Caption = FloatToStrF(tmin + 4.0*deltat,ffFixed,15,2)+ "C";
Labelx5 -> Caption = FloatToStrF(tmin + 5.0*deltat,ffFixed,15,2)+ "C";
Labelx6 -> Caption = FloatToStrF(tmin + 6.0*deltat,ffFixed,15,2)+ "C";
Labelx7 -> Caption = FloatToStrF(tmin + 7.0*deltat,ffFixed,15,2)+ "C";
Labelx8 -> Caption = FloatToStrF(tmin + 8.0*deltat,ffFixed,15,2)+ "C";

Labelt1 -> Caption = FloatToStrF(1.0*deltas,ffFixed,15,2);
Labelt2 -> Caption = FloatToStrF(2.0*deltas,ffFixed,15,2);
Labelt3 -> Caption = FloatToStrF(3.0*deltas,ffFixed,15,2);
Labelt4 -> Caption = FloatToStrF(4.0*deltas,ffFixed,15,2);
Labelt5 -> Caption = FloatToStrF(5.0*deltas,ffFixed,15,2);
Labelt6 -> Caption = FloatToStrF(6.0*deltas,ffFixed,15,2);
Labelt7 -> Caption = FloatToStrF(7.0*deltas,ffFixed,15,2);
Labelt8 -> Caption = FloatToStrF(8.0*deltas,ffFixed,15,2);
Labelt9 -> Caption = FloatToStrF(9.0*deltas,ffFixed,15,2);
Labelt10 -> Caption = FloatToStrF(10.0*deltas,ffFixed,15,2);
Labelt11 -> Caption = FloatToStrF(11.0*deltas,ffFixed,15,2);
Labelt12 -> Caption = FloatToStrF(12.0*deltas,ffFixed,15,2);

//clear

Image1->Canvas->Brush ->Color = clWhite;
Image1->Canvas->FillRect(Rect(0,0,480,320));

// grilles
Image1->Canvas->Pen->Color = clBlue; // couleur du trait
Image1->Canvas->Pen->Width = 1; // largeur du trait
Image1->Canvas->Pen->Style = psDot	; // Style du trait (pointill)

for (int i = 0 ; i<9 ; i++)       // 8 lignes
{
        Image1->Canvas->MoveTo(0 , 40*i);
        Image1->Canvas->LineTo(480 , 40*i);
}
for (int i = 0 ; i<13 ; i++)   // 12 colonnes
{
        Image1->Canvas->MoveTo(40*i , 0);
        Image1->Canvas->LineTo(40*i , 320);
}

Image1->Canvas->MoveTo(-100 , 160);
j=0 ;
Timer3->Enabled=true;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
// on arrive ici toutes les 30 ms
if (ComPort1->Connected==true)
{
        ComPort1->Write(tableau, 1); //Ecrit 1 octet de "tableau" sur le port srie
        // envoie le code ASCII 0x74 (caractre 't')
}
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Timer3Timer(TObject *Sender)
{

j++;
if (j>480)
{
        // on efface le demi cran gauche
        Image1->Canvas->Brush ->Color = clWhite;
        Image1->Canvas->FillRect(Rect(0,0,240,320));
        // grilles
        Image1->Canvas->Pen->Color = clBlue; // couleur du trait
        Image1->Canvas->Pen->Width = 1; // largeur du trait
        Image1->Canvas->Pen->Style = psDot	; // Style du trait (pointill)

        for (int i = 0 ; i<9 ; i++)       // 8 lignes
        {
                Image1->Canvas->MoveTo(0 , 40*i);
                Image1->Canvas->LineTo(480 , 40*i);
        }
        for (int i = 0 ; i<13 ; i++)   // 12 colonnes
        {
                Image1->Canvas->MoveTo(40*i , 0);
                Image1->Canvas->LineTo(40*i , 320);
        }
        j=1 ;
        Image1->Canvas->MoveTo(0 , y);
}
if (j==240)
{
        // on efface le demi cran droit
        Image1->Canvas->Brush ->Color = clWhite;
        Image1->Canvas->FillRect(Rect(240,0,480,320));
        // grilles
        Image1->Canvas->Pen->Color = clBlue; // couleur du trait
        Image1->Canvas->Pen->Width = 1; // largeur du trait
        Image1->Canvas->Pen->Style = psDot	; // Style du trait (pointill)

        for (int i = 0 ; i<9 ; i++)       // 8 lignes
        {
                Image1->Canvas->MoveTo(0 , 40*i);
                Image1->Canvas->LineTo(480 , 40*i);
        }
        for (int i = 0 ; i<13 ; i++)   // 12 colonnes
        {
                Image1->Canvas->MoveTo(40*i , 0);
                Image1->Canvas->LineTo(40*i , 320);
        }
        Image1->Canvas->MoveTo(239 , y);

}
Image1->Canvas->Pen->Color = clRed; // couleur du trait
Image1->Canvas->Pen->Width = 2; // largeur du trait

y =  -320.0*(temperature_moy - tmax)/(tmax - tmin);
Image1->Canvas->LineTo(j,y);

if (sauvegardeencours == true)
{
        // mise  jour fichier de sauvegarde
        time0 = TimeToStr(Time());
        if (time0 != timebak)   // une sauvegarde par seconde max.
        {
                FileWrite(iFileHandle, DateToStr(Date()).c_str(), DateToStr(Date()).Length());
                FileWrite(iFileHandle, &tabulation, 1);
                FileWrite(iFileHandle, time0.c_str(), time0.Length());
                FileWrite(iFileHandle, &tabulation, 1);
                FileWrite(iFileHandle, FloatToStrF(temperature_moy,ffFixed,15,2).c_str(), FloatToStrF(temperature_moy,ffFixed,15,2).Length());
                FileWrite(iFileHandle, &retour, 1);
                FileWrite(iFileHandle, &saut, 1);
        }
        timebak = time0;
}

}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button7Click(TObject *Sender)
{
ComPort1->Connected=true;  // ouverture du port
Button7->Enabled=false;
Button8->Enabled=true;
Button6->Enabled=false;

ButtonSauvegarde->Enabled=true;
sauvegardeencours = false;

GroupBox1 -> Enabled=true;

//clear

Image1->Canvas->Brush ->Color = clWhite;
Image1->Canvas->FillRect(Rect(0,0,480,320));


// grilles
Image1->Canvas->Pen->Color = clBlue; // couleur du trait
Image1->Canvas->Pen->Width = 1; // largeur du trait
Image1->Canvas->Pen->Style = psDot	; // Style du trait (pointill)

for (int i = 0 ; i<9 ; i++)       // 8 lignes
{
        Image1->Canvas->MoveTo(0 , 40*i);
        Image1->Canvas->LineTo(480 , 40*i);
}
for (int i = 0 ; i<13 ; i++)   // 12 colonnes
{
        Image1->Canvas->MoveTo(40*i , 0);
        Image1->Canvas->LineTo(40*i , 320);
}
Image1->Canvas->MoveTo(-100 , 160);
j = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
ComPort1->Connected=false;  // fermeture du port
Button7->Enabled=true;
Button8->Enabled=false;
Button6->Enabled=true;
Timer3->Enabled=false;
GroupBox1 -> Enabled=false;
ButtonSauvegarde->Enabled = false ;

if (sauvegardeencours == true)
{
        FileClose(iFileHandle);
        sauvegardeencours = false;
}

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComPort1RxChar(TObject *Sender, int Count)
{
// on arrive ici quand on reoit des donnes du port COM (logiquement toutes les 30 ms)

try
{
ComPort1->ReadStr(temp_lue, Count);
//Lit les "Count" octet(s) prsent(s) dans le buffer d'entre et le(s) place dans temp_lue
temp_lue = temp_lue.SubString(1,4); // par prcaution : on converve les 4 premiers caractres

for (int i=0 ; i<29 ; i++) temperature[i]=temperature[i+1];

temperature[29] = temp_lue.ToDouble(); //conversion de AnsiString en Double

// valeur moyenne
temperature_moy = 0.0;
for (int i=0 ; i<30 ; i++)
{
        temperature_moy = temperature_moy + temperature[i];
}
temperature_moy = temperature_moy/30.0;
}
catch(...)
{
Application->MessageBox("Erreur de format de rception !","Erreur 3",MB_OK);
}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
ComPort1->ShowSetupDialog();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
// mise  jour affichage de la temprature actuelle (toutes les 1 seconde)
Label6temp -> Caption = FloatToStrF(temperature_moy,ffFixed,15,1) + " C" ;   // affichage temprature actuelle
// affichage de l'heure courante
Label7time->Caption=TimeToStr(Time());   // AnsiString  hh:mm:ss
Label7date->Caption=DateToStr(Date());   // AnsiString 
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonSauvegardeClick(TObject *Sender)
{
// sauvegarde dans un fichier
if (sauvegardeencours == false)
{
AnsiString entete ="Suivi de temprature" ;
AnsiString entete0 ="(C) Fabrice Sincre" ;
AnsiString entete1 ="Date       ";
AnsiString entete2 ="Heure      ";
AnsiString entete3 ="Temprature (C)" ;
char szFileName[100];

int iLength;
if (SaveDialog1->Execute())
{
        if (FileExists(SaveDialog1->FileName))
        {
                fnsplit(SaveDialog1->FileName.c_str(), 0, 0, szFileName, 0);
                strcat(szFileName, ".BAK");
                RenameFile(SaveDialog1->FileName, szFileName);
        }
        iFileHandle = FileCreate(SaveDialog1->FileName);

        FileWrite(iFileHandle, entete.c_str(), entete.Length());
        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);
        FileWrite(iFileHandle, entete0.c_str(), entete0.Length());
        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);
        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);
        FileWrite(iFileHandle, entete1.c_str(), entete1.Length());
        FileWrite(iFileHandle, &tabulation, 1);
        FileWrite(iFileHandle, entete2.c_str(), entete2.Length());
        FileWrite(iFileHandle, &tabulation, 1);
        FileWrite(iFileHandle, entete3.c_str(), entete3.Length());
        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);
        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);

        sauvegardeencours = true ;
        ButtonSauvegarde->Enabled=false;
}
}
}
//---------------------------------------------------------------------------

